<?php
	if(isset($_POST['submit'])) {
		if(!isset($_POST['card_type']) || !isset($_POST['card_amount']) || !isset($_POST['serial']) || !isset($_POST['pin'])) {
			$err = 'Bạn cần nhập đầy đủ thông tin';
		} else {
			$type = $_POST['card_type'];
			$amount = $_POST['card_amount'];
			$seri = $_POST['serial'];
			$pin = $_POST['pin'];
			
			if($type == '' || $amount == '' || $seri == '' || $pin == '') {
				$err = 'Bạn cần nhập đầy đủ thông tin';
			} else {
				require_once('config.php'); //gọi đến file config.php để chèn vào code.
				require_once('function.php'); //gọi đến file function.php để chèn vào code.
				
				$dataPost = array(
					'api_key' => $key,
					'api_secret' => $secret,
					'card_type' => $type,
					'card_amount' => $amount,
					'card_serial' => $seri,
					'card_pin' => $pin,
					'content' => 'noi dung' //Nội dung bạn có thể điền ID User trên website bạn để nhận biết khi có kết quả gạch thẻ trả về.
				);
				
				$post = curl_post($url_charge, $dataPost);
				
				if($post == '')
					$err = 'Lỗi hệ thống, vui lòng thử lại sau';
				else {
					$obj = json_decode($post, false);
					if(isset($obj->status)) {
						if($obj->status > 0) {
							//Gửi thẻ thành công, đợi duyệt.
							echo '<pre>';
							print_r($obj);
							echo '</pre>';
						} else {
							//Thất bại
							echo '<pre>';
							print_r($obj);
							echo '</pre>';
						}
					} else 
						$err = 'Lỗi hệ thống, vui lòng thử lại sau';
				}
			}
		}
	}
?>
<!DOCTYPE html>
<html>
<head>
	<meta charset="UTF-8">
	<title>Nạp thẻ</title>
	<meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
	<link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.1.1/css/bootstrap.min.css" integrity="sha384-WskhaSGFgHYWDcbwN70/dfYBj47jz9qbsMId/iRN3ewGhXQFZCSftd1LZCfmhktB" crossorigin="anonymous">
</head>
<body>
	<div class="container">
		<div class="row" style="margin-top: 50px;">
			<div class="col-md-8" style="float:none;margin:0 auto;">
				<form method="POST" action="">
					<div class="form-group">
						<label>Loại thẻ:</label>
						<select class="form-control" name="card_type">
							<option value="">Chọn loại thẻ</option>
							<option value="1">Viettel</option>
							<option value="2">Mobifone</option>
							<option value="4">Vinaphone</option>
							<option value="5">Gate</option>
							<option value="6">Zing</option>
							<option value="7">Megacard</option>
							<option value="8">BIT</option>
							<option value="9">Garena</option>
						</select>
					</div>
					<div class="form-group">
						<label>Mệnh giá:</label>
						<select class="form-control" name="card_amount">
							<option value="">Chọn mệnh giá</option>
							<option value="10000">10.000</option>
							<option value="20000">20.000</option>
							<option value="30000">30.000</option>
							<option value="50000">50.000</option>
							<option value="100000">100.000</option>
							<option value="200000">200.000</option>
							<option value="300000">300.000</option>
							<option value="500000">500.000</option>
						</select>
					</div>
					<div class="form-group">
						<label>Số seri:</label>
						<input type="text" class="form-control" name="serial" />
					</div>
					<div class="form-group">
						<label>Mã thẻ:</label>
						<input type="text" class="form-control" name="pin" />
					</div>
					<div class="form-group">
						<?php echo (isset($err)) ? '<div class="alert alert-danger" role="alert">'.$err.'</div>' : ''; ?>
					</div>
					<div class="form-group">
						<button type="submit" class="btn btn-success btn-block" name="submit">NẠP NGAY</button>
					</div>
				</form>
			</div>
		</div>
	</div>
<script src="https://code.jquery.com/jquery-3.3.1.slim.min.js" integrity="sha384-q8i/X+965DzO0rT7abK41JStQIAqVgRVzpbzo5smXKp4YfRvH+8abtTE1Pi6jizo" crossorigin="anonymous"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.3/umd/popper.min.js" integrity="sha384-ZMP7rVo3mIykV+2+9J3UJ46jBk0WLaUAdn689aCwoqbBJiSnjAK/l8WvCWPIPm49" crossorigin="anonymous"></script>
<script src="https://stackpath.bootstrapcdn.com/bootstrap/4.1.1/js/bootstrap.min.js" integrity="sha384-smHYKdLADwkXOn1EmN1qk/HfnUcbVRZyYmZ4qpPea6sjB/pTJ0euyQp0Mk8ck+5T" crossorigin="anonymous"></script>
</body>
</html>